叁叁肆

这个世界会好吗

453篇博客

兼容性测试中如何切换和管理多个JDK版本

叁叁肆2018-11-22 13:02

此文已由作者邹珍珍授权网易云社区发布。

欢迎访问网易云社区,了解更多网易技术产品运营经验。


一、测试背景:

  项目对外提供JAR包,需要测试该JAR包对不同JDK版本(1.6至1.9版本)的兼容性。下面主要介绍在兼容性测试中,JDK多版本共存时如何配置环境变量,以及如何在IDE中切换JDK版本。
  首先说明,在对JAR包进行JDK版本兼容性测试的时候,配置环境变量是非必须操作,因为只要机子上安装了多个JDK版本,不管是Eclipse还是IDEA都可以手动配置项目所使用的JDK版本。但是,由于大部分JAVA程序都会默认去环境变量中取JAVA_HOME这个变量,比如Eclipse,若不手动去配置会默认使用环境变量中配置的JDK版本,故还是需要知道如何在一台机子上管理多个JDK版本,免得安装了多个JDK版本后造成一些不必要的麻烦。

二、JDK多版本共存时环境配置
 1. 下载并安装需要的JDK版本 下载地址
 
    测试需要,本人分别下载和安装了JDK1.9,JDK1.8,JDK1.7和JDK1.6四个版本。
  2. 配置环境变量-创建五个JAVA_HOME。
   JAVA6_HOME:存放JDK1.6的安装路径;
   JAVA7_HOME:存放JDK1.7的安装路径;
   JAVA8_HOME:存放JDK1.8的安装路径;
   JAVA9_HOME:存放JDK1.9的安装路径。
   JAVA_HOME:若需JDK1.6版本变量值设为%JAVA6_HOME%,若需1.9版本变量值设为%JAVA9_HOME%,便于切换。
 
  3. 配置环境变量-创建CLASSPATH,变量值为.;%JAVA_HOME%\lib;%JAVA_HOME%\lib\tools.jar          
  4. 配置环境变量-Path,新增值为%JAVA_HOME%\bin
  5.  删除自动配置(很重要)
   由于JDK安装程序会把java.exe,javaw.exe,javareg.exe这三个可执行文件拷贝到%SystemRoot%/system32目录下,
   其中JDK1.8版本还会将以上三个可执行文件拷贝到C:\ProgramData\Oracle\Java\javapath目录下,
   且以上路径被操作系统设置为最高优先权的PATH搜索路径,因此会影响到JDK版本切换。
 
   故需要分别删除以下目录下的三个可执行文件java.exe,javaw.exe,javareg.exe:
  •   C:\Windows\System32
  •   C:\ProgramData\Oracle\Java\javapath
   6. 验证JDK正确切换
     更换JAVA_HOME内不同的变量值,打开cmd,输入java -version,查看版本。
三、IDEA配置多JDK版本
  增加JDK版本: File --> Project Structure --> Platform Settings --> SDKs --> +

  项目更换JDK版本: File --> Project Structure --> Project Settings --> Project

四、修改Maven项目的pom.xml文件
最后还需要注意,使用的JDK版本更换后,需要在Maven的pom.xml文件中修改compiler插件-source参数,改为指定的JDK版本,否则会报错: Error:java: 无效的源版本: 8
报错原因是,JDK的版本与项目的要求不一致,源码编写使用的是JAVA9语法,但是pom.xml文件中却指定源码通过JDK1.8(-source 1.8)来编译。
<plugin>
    <groupId>org.apache.maven.plugins</groupId>
    <artifactId>maven-compiler-plugin</artifactId>
    <version>3.1</version>
    <configuration>
        <source>1.8</source> <!-- 源代码使用的开发版本 -->
        <target>1.8</target> <!-- 需要生成的目标class文件的编译版本 -->

        <!-- 这下面的是可选项 -->
        <meminitial>128m</meminitial>
        <maxmem>512m</maxmem>
        <fork>true</fork> <!-- fork is enable,用于明确表示编译版本配置的可用 --> 
        <compilerVersion>1.8</compilerVersion>

        <!-- 这个选项用来传递编译器自身不包含但是却支持的参数选项 -->
        <compilerArgument>-verbose -bootclasspath ${java.home}\lib\rt.jar</compilerArgument>

    </configuration>
</plugin


免费领取验证码、内容安全、短信发送、直播点播体验包及云服务器等套餐

更多网易技术、产品、运营经验分享请点击